#ifndef VERTEX_H
#define VERTEX_H 
#include <vector>

template <class Label, class Mark, class Edge>
class Vertex {
protected:
    Label label;
	Mark mark;
	Edge edges;
public:
	template <class Edge>
	class edgeIterator {
	private:
		vector<Edge>::iterator edgeIter;
	public:
	edgeIterator<Edge> begin() {
		vector<Edge>::iterator iter;
		iter = edges.begin();
		return iter;
	} // end begin
	iterator<T> end() {
		vector<Edge>::iterator iter;
		iter = edges.end();
		return iter;
	} // end 
//		edgeIterator() { ptr = NULL; }
		bool operator==(edgeIterator<Edge> RHS) {
			return edgeIter==RHS.edgeIter;
		}
		bool operator!=(edgeIterator<Edge> RHS) {
			return edgeIter != RHS.edgeIter;
		} 
		edgeIterator<Edge> & operator=(edgeIterator<Edge> RHS) {
			edgeIter = RHS.edgeIter;
			return *this;
		} // end operator=

		edgeIterator<Edge> & operator++() {
			edgeIter++;
			return *this;
		} // end operator++

		edgeIterator<Edge> & operator++(int) {
			edgeIter++;
			return *this;
		} // end operator++
		edgeIterator<Edge> & operator--() {
			edgeIter--;
			return *this;
		} // end operator--
		edgeIterator<Edge> & operator--(int) {
			edgeIter--;
			return *this;
		} // end operator--
		Edge operator*() {
			return *edgeIter;
		} // end operator*
	friend class Vertex;
	}; // end EdgeIterator class

    Vertex (Label, Mark);
    Label& getLabel() const;
	void setLabel(const Label&);
    Mark& getMark() const;
	void setMark(const Mark&);
	void addEdgeTo(const Vertex& toVertex, double weight = 0.0);
	Edge& getEdgeTo(const Vertex& toVertex) const;


};

template <class Label, class Mark, class Edge>
void Vertex<Label,Mark,Edge>::setMark(const Mark& newMark) const {
	mark = newMark;
} //end setMark

template <class Label, class Mark, class Edge>
Mark& Vertex<Label,Mark,Edge>::getMark() const {
	return mark;
} //end getMark

template <class Label, class Mark, class Edge>
void Vertex<Label,Mark,Edge>::setLabel(const Label& newLabel) const {
	label = newLabel;
} //end setLabel

template <class Label, class Mark, class Edge>
Label& Vertex<Label,Mark,Edge>::getLabel() const {
	return label;
} //end getLabel

template <class Label, class Mark, class Edge>
Vertex<Label,Mark,Edge>::Vertex(Label aLabel, Mark aMark) {
	label = aLabel;
	mark = aMark;
}

#endif